package org.jdtaus.core.container.ri.client;

import java.util.HashMap;
import java.util.Map;
import java.util.Locale;
import java.util.ResourceBundle;
import java.text.MessageFormat;

abstract class DefaultModelBundle{

private static final Map cache;

static
{
    cache = new HashMap();
    getInvalidMultiplicityText(Locale.getDefault());
    getNoValidationWarningText(Locale.getDefault());
    getMissingImplementationText(Locale.getDefault());
    getUnresolvedImplementationText(Locale.getDefault());
}

public static String getInvalidMultiplicityText(final Locale locale) {
    return getMessage("invalidMultiplicity", locale);
}

public static MessageFormat getInvalidMultiplicityMessage(Locale locale) {
    if(locale == null) { locale = Locale.getDefault(); }
return new MessageFormat(getMessage("invalidMultiplicity", locale), locale);
}

public static String getNoValidationWarningText(final Locale locale) {
    return getMessage("noValidationWarning", locale);
}

public static MessageFormat getNoValidationWarningMessage(Locale locale) {
    if(locale == null) { locale = Locale.getDefault(); }
return new MessageFormat(getMessage("noValidationWarning", locale), locale);
}

public static String getMissingImplementationText(final Locale locale) {
    return getMessage("missingImplementation", locale);
}

public static MessageFormat getMissingImplementationMessage(Locale locale) {
    if(locale == null) { locale = Locale.getDefault(); }
return new MessageFormat(getMessage("missingImplementation", locale), locale);
}

public static String getUnresolvedImplementationText(final Locale locale) {
    return getMessage("unresolvedImplementation", locale);
}

public static MessageFormat getUnresolvedImplementationMessage(Locale locale) {
    if(locale == null) { locale = Locale.getDefault(); }
return new MessageFormat(getMessage("unresolvedImplementation", locale), locale);
}

private static String getMessage(final String key, Locale locale) {
    if(locale == null) {locale = Locale.getDefault(); }
    Map msgCache = (Map) cache.get(locale);
    if(msgCache == null)
    {
        msgCache = new HashMap();
        cache.put(locale, msgCache);
    }

    String msg = (String) msgCache.get(key);
    if(msg == null)
    {
        msg = ResourceBundle.getBundle(
        "org.jdtaus.core.container.ri.client.DefaultModel", locale).getString(key);
        msgCache.put(key, msg);
    };
    return msg;
}

}
